#include "lcd.h"
#include "main.h"


void lcd_enable() {
	//set enable bit and hold it
	PORTD |= (1 << lcd_cmd_e);
	_delay_us(50);
	PORTD &= ~(1 << lcd_cmd_e);
	_delay_us(50);
}

void lcd_enable_cmd() {
	//set enable bit and hold it
	PORTD |= (1 << lcd_cmd_e);
	_delay_us(50);
	PORTD &= ~(1 << lcd_cmd_e);
	_delay_us(50);	
}

void lcd_send_cmd(unsigned char cmd) {
	
	//set cmd mode
	PORTD &= ~(1 << lcd_cmd_rs);
	
	PORTC = cmd;
	//wait till command is active
	lcd_enable_cmd();
}

void lcd_send_data(char data) {	
	//set data mode
	PORTD |= (1 << lcd_cmd_rs);
	PORTC = data;
	lcd_enable();
	_delay_ms(10);
}

void lcd_send(char data[]) {
	int i;
	for (i = 0; i < lcd_max_col; i++) {
		if (data[i] != 0x00) {
			lcd_send_data(data[i]);
		} else break;
	}
}

void init_lcd() {
	//set output
	DDRD |= (1 << lcd_cmd_rs_ddr);
	DDRD |= (1 << lcd_cmd_rw_ddr);
	DDRD |= (1 << lcd_cmd_e_ddr);
	
	DDRC |= (1 << lcd_data0_ddr);
	DDRC |= (1 << lcd_data1_ddr);
	DDRC |= (1 << lcd_data2_ddr);
	DDRC |= (1 << lcd_data3_ddr);
	DDRC |= (1 << lcd_data4_ddr);
	DDRC |= (1 << lcd_data5_ddr);
	DDRC |= (1 << lcd_data6_ddr);
	DDRC |= (1 << lcd_data7_ddr);

	//wait till port is configured
	_delay_ms(100);
	
	//send lcd-config commands
	lcd_send_cmd(lcd_config);
	_delay_ms(20);
	lcd_send_cmd(lcd_cursorconfig);
	_delay_ms(20);
	lcd_send_cmd(lcd_shiftconfig);
	_delay_ms(20);
	lcd_send_cmd(lcd_clear_screen);	
	_delay_ms(20);
	
	
}
