#ifndef LCD_H_
#define LCD_H_
#include "main.h"
#include <util/delay.h> 
#include <avr/io.h>

//lcd data pins
#define lcd_data0 		PC0
#define lcd_data1 		PC1
#define lcd_data2 		PC2
#define lcd_data3 		PC3
#define lcd_data4 		PC4
#define lcd_data5 		PC5
#define lcd_data6 		PC6
#define lcd_data7 		PC7
//lcd data ddr
#define lcd_data0_ddr	DDC0
#define lcd_data1_ddr	DDC1
#define lcd_data2_ddr	DDC2
#define lcd_data3_ddr	DDC3
#define lcd_data4_ddr	DDC4
#define lcd_data5_ddr	DDC5
#define lcd_data6_ddr	DDC6
#define lcd_data7_ddr	DDC7

//lcd cmd pins
#define lcd_cmd_e		PD7
#define lcd_cmd_rw 		PD6
#define lcd_cmd_rs		PD5
//lcd cmd ddr
#define lcd_cmd_e_ddr	DDD7
#define lcd_cmd_rw_ddr	DDD6
#define lcd_cmd_rs_ddr	DDD5

#define lcd_max_col 16
#define lcd_max_row 2

// 0x0F = Cursor shown and blinking
// 0x0C = Cursor not shown
#define lcd_cursorconfig	0x06
#define lcd_shiftconfig		0x04
#define lcd_config 			0x0C
#define lcd_clear_screen	0x01
#define lcd_cursor_home		0x02
#define lcd_cursor_left		0x10
#define lcd_cursor_right	0x1E
#define lcd_row_1			0x80
#define lcd_row_2			0xC0

void init_lcd();
void lcd_enable();
void lcd_enable_cmd();
void lcd_send_cmd(unsigned char cmd);
void lcd_send_data(char data);
void lcd_send(char data[]);

#endif /*LCD_H_*/
